#include <cstdio>
#include <algorithm>

inline long long gcd(long long a, long long b)
{
    long long c;
    if(a < b){c = a; a = b; b = c;}
    while(b){c = a % b; a = b; b = c;}
    return a;
}

FILE *in = stdin;
FILE *out = stdout;

long long a[10100];

inline void solve()
{
    int n, k;
    long long p, q, r;
    char f;
    fscanf(in, "%d %d %lld\n%c", &n, &k, &p, &f);
    for(int i = 0; i < n; i++) fscanf(in, "%lld", &a[i]);

    if(k == n) {fprintf(out, "X"); return;}///THERE ARE NO NUMBERS LEFT
    if((f == 'X') ^ (k % 2)){fprintf(out, "Y"); return;}///Y DOES THE LAST TURN
    if(k == 1)///THERE IS ONLY ONE TURN (AND X DOES IT)
    {
        long long sum = 0;
        for(int i = 0; i < n; i++) sum = (sum + a[i]) % p;
        for(int i = 0; i < n; i++) if(a[i] == sum) {fprintf(out, "X"); return;}
        fprintf(out, "Y"); return;
    }
    if((n - k) % 2 == 1) {fprintf(out, "Y"); return;}///ODD NUMBER OF NUMBERS LEFT

    q = gcd(p, (long long)((n - k) / 2));
    std::sort(a, a + n);
    for(int i = 0; i < q; i++)
    {
        int notpaired = 0;
        r = i * (p / q);
        int t, j1, j2;
        for(t = 0; t < n && a[t] <= r; ++t);
        for(j1 = 0, j2 = t-1; j1 < j2; j1++, j2--)
        {
            if(a[j1] + a[j2] > r) {notpaired++; j1--;}
            else if(a[j1] + a[j2] < r) {notpaired++; j2++;}
        }
        if(j1 == j2) notpaired++;
        r = p + r;
        for(j1 = t, j2 = n-1; j1 < j2; j1++, j2--)
        {
            if(a[j1] + a[j2] > r) {notpaired++; j1--;}
            else if(a[j1] + a[j2] < r) {notpaired++; j2++;}
        }
        if(j1 == j2) notpaired++;
        if(notpaired < 2) {fprintf(out, "X"); return;}
    }
    fprintf(out, "Y"); return;
}
int main()
{
    //in = fopen("test10.in", "r"); out = fopen("test10.sol", "w");
    int t;
    fscanf(in, "%d", &t);
    while(t--) solve();
    fprintf(out, "\n");
    return 0;
}
